# Quantum Mechanical Keyboard Firmware
> This is a fork of the official [GitHub Repo](https://github.com/qmk/qmk_firmware) of QMK. 
> This repo only contains userspace for my layouts and the layouts themselves. 

## Boards

The repo only contains keymaps for my own boards. The keymaps can be changed to other layouts as well. 

### Current

* [Melody96](keyboards/melody96)
* [UT47.5](FrederikBaerentsen/QMK/src/branch/master/keyboards/ut472)
* [Kyria](FrederikBaerentsen/QMK/src/branch/master/keyboards/kyria)
* [Drop ALT](FrederikBaerentsen/QMK/src/branch/master/keyboards/massdrop/alt)

### Incoming

* [Lily58](FrederikBaerentsen/QMK/src/branch/master/keyboards/lily58) (Est. Q2)
* [SPACE65:CyberVoyager](https://graystudio.club/) (Est. Q3/Q4)
* [Rukia R2](https://www.mintautumn.com/) (Est. Q4)
* [Klippe T R4](https://mekanisk.co/) (Est. Q3)
* [ElectroType Acrylic Alice](https://switchcouture.com/) (Est. Q2/Q3)
* [Uno](https://www.reddit.com/r/mechmarket/comments/gyijm7/gb_uno/) (Est. Q3)

## Keyboard-layout-editor

All the boards should be available on keyboard-layout-editor.com.

* [Kyria](http://www.keyboard-layout-editor.com/#/gists/e0a6bd87b1e727555ec5c5c1b82c3670)
* [Lily58](http://www.keyboard-layout-editor.com/#/gists/ef22a088bdb96962de3b8b5ae4cd3951)
* [UT47.2](http://www.keyboard-layout-editor.com/#/gists/5ab8838c07cdb2fc41f3dd9a8b177bf4)
* [Melody96](http://www.keyboard-layout-editor.com/#/gists/8a16447546079e942b151523ac2356b8)

## Keymaps

All my keymaps are based on the userspace from [Drashna](https://github.com/qmk/qmk_firmware/tree/master/users/drashna). This is probably the most advanced userspace I've seen and I have heavily borrowed from it (read: copy/paste). 

The main idea is to have a wrapper where let's say QWERTY is stored. This wrapper can be used for both UT47.2 and Kyria because they both have the same 3x10 keys for alphas. The mods are different, but that does not matter. 

A QWERTY wrapper can look like: 

```
#define _________________QWERTY_L1_________________        KC_Q,    KC_W,    KC_E,    KC_R,    KC_T
#define _________________QWERTY_L2_________________        KC_A,    KC_S,    KC_D,    KC_F,    KC_G
#define _________________QWERTY_L3_________________        KC_Z,    KC_X,    KC_C,    KC_V,    KC_B

#define _________________QWERTY_R1_________________        KC_Y,    KC_U,    KC_I,    KC_O,    KC_P
#define _________________QWERTY_R2_________________        KC_H,    KC_J,    KC_K,    KC_L,    KC_SCLN
#define _________________QWERTY_R3_________________        KC_N,    KC_M,    KC_COMM, KC_DOT,  KC_SLASH
```

When added to Kyria it will look like:

<img src="https://gitea.baerentsen.space/FrederikBaerentsen/QMK/raw/branch/master/UT472_QWERTY.PNG" width="500">

And on UT47.2: 

<img src="https://gitea.baerentsen.space/FrederikBaerentsen/QMK/raw/branch/master/Kyria_QWERTY.PNG" width="500">

Both has the same QWERTY layout and we can add mods around it. 
This isn't super useful for just alphas, but adding symbols and other layers it suddenly becomes much easier to add new keyboards. 

# Official QMK Information 
Below is information about the official [GitHub Repo](https://github.com/qmk/qmk_firmware)

[![Current Version](https://img.shields.io/github/tag/qmk/qmk_firmware.svg)](https://github.com/qmk/qmk_firmware/tags)
[![Build Status](https://travis-ci.org/qmk/qmk_firmware.svg?branch=master)](https://travis-ci.org/qmk/qmk_firmware)
[![Discord](https://img.shields.io/discord/440868230475677696.svg)](https://discord.gg/Uq7gcHh)
[![Docs Status](https://img.shields.io/badge/docs-ready-orange.svg)](https://docs.qmk.fm)
[![GitHub contributors](https://img.shields.io/github/contributors/qmk/qmk_firmware.svg)](https://github.com/qmk/qmk_firmware/pulse/monthly)
[![GitHub forks](https://img.shields.io/github/forks/qmk/qmk_firmware.svg?style=social&label=Fork)](https://github.com/qmk/qmk_firmware/)

This is a keyboard firmware based on the [tmk\_keyboard firmware](https://github.com/tmk/tmk_keyboard) with some useful features for Atmel AVR and ARM controllers, and more specifically, the [OLKB product line](https://olkb.com), the [ErgoDox EZ](https://ergodox-ez.com) keyboard, and the [Clueboard product line](https://clueboard.co).

## Documentation

* [See the official documentation on docs.qmk.fm](https://docs.qmk.fm)

The docs are powered by [Docsify](https://docsify.js.org/) and hosted on [GitHub](https://github.com/qmk/qmk_firmware/docs/). They are also viewable offline; see [Previewing the Documentation](https://docs.qmk.fm/#/contributing?id=previewing-the-documentation) for more details.

You can request changes by making a fork and opening a [pull request](https://github.com/qmk/qmk_firmware/pulls), or by clicking the "Edit this page" link at the bottom of any page.

## Maintainers

QMK is developed and maintained by Jack Humbert of OLKB with contributions from the community, and of course, [Hasu](https://github.com/tmk). The OLKB product firmwares are maintained by [Jack Humbert](https://github.com/jackhumbert), the Ergodox EZ by [ZSA Technology Labs](https://github.com/zsa), the Clueboard by [Zach White](https://github.com/skullydazed), and the Atreus by [Phil Hagelberg](https://github.com/technomancy).

## Official Website

[qmk.fm](https://qmk.fm) is the official website of QMK, where you can find links to this page, the documentation, and the keyboards supported by QMK.
